package com.zt.plat.module.qms.common.data.service;

import com.zt.plat.framework.common.pojo.CommonResult;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.qms.common.data.dal.dataobject.DataCollectionDO;
import com.zt.plat.module.qms.common.data.controller.vo.DataCollectionPageReqVO;
import com.zt.plat.module.qms.common.data.controller.vo.DataCollectionRespVO;
import com.zt.plat.module.qms.common.data.controller.vo.DataCollectionSaveReqVO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * 数据集 Service 接口
 *
 * @author 后台管理
 */
public interface DataCollectionService {

    DataCollectionDO getLatestDataCollectionByKey(String key);

    /*获取分类树数据*/
    List<DataCollectionDO> getTreeData();

    //保存数据集
    CommonResult<String> saveDataCollection(@Valid DataCollectionSaveReqVO createReqVO);
    CommonResult<String> saveDataCollectionWithNewVersion(@Valid DataCollectionSaveReqVO createReqVO);

    //保存分类
    CommonResult<DataCollectionRespVO> saveClassify(@Valid DataCollectionSaveReqVO createReqVO);

    //更新后代节点路径-递归调用
    CommonResult<String> updateAllIdPath(Long parentId, Integer level);

    /**
     * 创建数据集
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    DataCollectionRespVO createDataCollection(@Valid DataCollectionSaveReqVO createReqVO);

    /**
     * 更新数据集
     *
     * @param updateReqVO 更新信息
     */
    void updateDataCollection(@Valid DataCollectionSaveReqVO updateReqVO);

    /**
     * 删除数据集
     *
     * @param id 编号
     */
    void deleteDataCollection(Long id);

    /**
    * 批量删除数据集
    *
    * @param ids 编号
    */
    void deleteDataCollectionListByIds(List<Long> ids);

    /**
     * 获得数据集
     *
     * @param id 编号
     * @return 数据集
     */
    DataCollectionDO getDataCollection(Long id);

    /**
     * 获得数据集分页
     *
     * @param pageReqVO 分页查询
     * @return 数据集分页
     */
    PageResult<DataCollectionDO> getDataCollectionPage(DataCollectionPageReqVO pageReqVO);

    List<DataCollectionDO> listByParId(Long parId);
}